#include "trackerworker.h"
#include <QThread>
#include "frontend_common.h"
#include "frontend_tracker.h"
#include "quaditem.h"
#include <QDebug>

TrackerWorker::TrackerWorker() :
    QObject(), conn(NULL)
{
}

TrackerWorker::~TrackerWorker()
{
    disconnectBackend();
}

void TrackerWorker::connectBackend()
{
    if (conn == NULL) {
        conn = ucart_backendConnect();
        emit (connected());
    } else {
        qInfo() << "Attempted to connect trackerworker when already connected!";
    }
}

void TrackerWorker::disconnectBackend()
{
    if (conn) {
         ucart_backendDisconnect(conn);
         conn = NULL;
         emit (disconnected());
    }
}

void TrackerWorker::process()
{
    if (conn) {
        struct frontend_tracker_data td;
        frontend_track(conn, &td);

        emit finished(td.longitudinal, td.lateral, td.height, td.pitch, td.roll, td.yaw);
    }
}
